/*
 *  DO NOT EDIT THIS FILE   (checkopt.h)
 *  
 *  It has been autogen-ed  Wednesday March  8, 2000 at 06:48:10 PM CET
 *  From the definitions    ./checkopt.def
 *  and the template file   options.tpl
 */

/*
 *  This file contains the programmatic interface to the
 *  Automated Options generated for the sharesecret program.
 *  These macros are documented in the AutoGen info file
 *  in the "Autoopts" chapter.  Please refer to that doc
 *  for usage help.
 */

#ifndef SHARESECRET_CHECKOPT_H
#define SHARESECRET_CHECKOPT_H

/*
 * Sharesecret copyright 2000 Stefan Karrmann
 *
 * Sharesecret is free software.
 * 
 * You may redistribute it and/or modify it under the terms of the
 * GNU General Public License, as published by the Free Software
 * Foundation; either version 2, or (at your option) any later version.
 * 
 * Sharesecret is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Sharesecret.  See the file "COPYING".  If not,
 * write to:  The Free Software Foundation, Inc.,
 *            59 Temple Place - Suite 330,
 *            Boston,  MA  02111-1307, USA.
 */
#include <options.h>

/*
 *  Enumeration of each option:
 */
typedef enum {
        INDEX_OPT_OUTPUT           =  0,
        INDEX_OPT_NO_WARN          =  1,
        INDEX_OPT_QUIET            =  2,
        INDEX_OPT_SILENT           =  3,
        INDEX_OPT_BRIEF            =  4,
        INDEX_OPT_VERBOSE          =  5,
        INDEX_OPT_JOIN             =  6,
        INDEX_OPT_SPLIT            =  7,
        INDEX_OPT_MIN              =  8,
        INDEX_OPT_SECRET           =  9,
        INDEX_OPT_VERSION          = 10,
        INDEX_OPT_HELP             = 11,
        INDEX_OPT_MORE_HELP        = 12
} teOptIndex;

#define OPTION_CT    13
#define SHARESECRET_VERSION       "0.1.0"
#define SHARESECRET_FULL_VERSION  "sharesecret - ShareSecret joins and splits secrets securely. - Ver. 0.1.0"

/*
 *  Interface defines for all options.  Replace "n" with
 *  the UPPER_CASED option name (as in the teOptIndex
 *  enumeration above).  e.g. HAVE_OPT( OUTPUT )
 */
#define     DESC(n)     sharesecretOptions.pOptDesc[INDEX_OPT_ ## n]
#define     HAVE_OPT(n) (! UNUSED_OPT(&DESC(n)))
#define      OPT_ARG(n) (DESC(n).pzLastArg)
#define    STATE_OPT(n) (DESC(n).fOptState & OPTST_SET_MASK)
#define    COUNT_OPT(n) (DESC(n).optOccCt)
#define    ISSEL_OPT(n) (SELECTED_OPT(&DESC(n)))
#define ISUNUSED_OPT(n) (UNUSED_OPT(& DESC(n)))
#define  ENABLED_OPT(n) (! DISABLED_OPT(& DESC(n)))
#define  STACKCT_OPT(n) (((tArgList*)(DESC(n).optCookie))->useCt)
#define STACKLST_OPT(n) (((tArgList*)(DESC(n).optCookie))->apzArgs)
#define    CLEAR_OPT(n) STMTS( \
                DESC(n).fOptState &= OPTST_PERSISTENT;   \
                if ( (DESC(n).fOptState & OPTST_INITENABLED) == 0) \
                    DESC(n).fOptState |= OPTST_DISABLED; \
                DESC(n).optCookie = (void*)NULL )

/*
 *  Interface defines for specific options.
 */
#define VALUE_OPT_OUTPUT         'o'
#define OPT_VALUE_OUTPUT         ((int)(OPT_ARG(OUTPUT)))
#define VALUE_OPT_NO_WARN        1
#define VALUE_OPT_QUIET          'q'
#define VALUE_OPT_SILENT         'q'
#define VALUE_OPT_BRIEF          4
#define VALUE_OPT_VERBOSE        'V'
#define VALUE_OPT_JOIN           'j'
#define VALUE_OPT_SPLIT          's'
#define OPT_VALUE_SPLIT          ((int)(OPT_ARG(SPLIT)))
#define WHICH_OPT_SPLIT          (DESC(SPLIT).optActualValue)
#define WHICH_IDX_SPLIT          (DESC(SPLIT).optActualIndex)
#define VALUE_OPT_MIN            'm'
#define OPT_VALUE_MIN            ((int)(OPT_ARG(MIN)))
#define VALUE_OPT_SECRET         'S'
#define OPT_VALUE_SECRET         ((int)(OPT_ARG(SECRET)))

#define VALUE_OPT_VERSION        'v'
#define VALUE_OPT_HELP           '?'
#define VALUE_OPT_MORE_HELP      '!'

/*
 *  Interface defines not associated with particular options
 */
#define  ERRSKIP_OPTERR STMTS( sharesecretOptions.fOptSet &= ~OPTPROC_ERRSTOP )
#define  ERRSTOP_OPTERR STMTS( sharesecretOptions.fOptSet |= OPTPROC_ERRSTOP )
#define  RESTART_OPT(n) STMTS( \
                sharesecretOptions.curOptIdx = (n); \
                sharesecretOptions.pzCurOpt  = (char*)NULL )
#define    START_OPT    RESTART_OPT(1)
#define     USAGE(c)    (*sharesecretOptions.pUsageProc)( &sharesecretOptions, c )

/* * * * * *
 *
 *  Declare the sharesecret option descriptor.
 */
#ifdef  __cplusplus
extern "C" {
#endif

extern tOptions   sharesecretOptions;

#ifdef  __cplusplus
}
#endif
#endif /* SHARESECRET_CHECKOPT_H */

